#ifdef GL_ES
precision mediump float;
#endif

uniform float rows;
uniform float cols;
uniform float fps;

varying highp vec2 vtex0;
attribute vec2 tex0;



void main()
{
    float frame = mod (floor (elapsed_time * fps), rows * cols);
    float row   = floor (frame / cols);
    float col   = frame - (cols * row); // modulo using previous floored divide (row).

    vec2 delta_st = 1.0 / vec2 (cols, rows);

    vtex0 = tex0;
    vtex0.st *= delta_st.st;
    vtex0.st += (delta_st * vec2 (col, row));

    gl_Position = ix_transform();
}


