varying vec2 vtex0;

attribute vec2 tex0;
attribute vec2 tex1;

uniform vec2 view_dimm;

// Would be 0.5 ^ 24 on Metal, but OpenGL is -1 to 1
const highp float MIN_24BIT_ZBUFFER_INCREMENT = pow(0.5, 23.0);
//Sadly a multiple is necessary in the absence of a normal.
//With a vertex normal (which we could add), we could start the bias low,
// then increase it as polygons approach perpendicular to the view direction.
// (Face normals would be better but there's no performant way to use them).
const float MULTIPLE = 3.0;
const highp float Z_BUFFER_OFFSET = MULTIPLE * MIN_24BIT_ZBUFFER_INCREMENT;
void main()
{
	vcol = ix_vertex_color();
    vtex0 = compute_vertex_uv(tex0);

    vec4 position = ix_transform();
    position.z -= position.w * Z_BUFFER_OFFSET;
    gl_Position = position;
}
