varying highp vec2 vtex0;

uniform sampler2D diffuse;

void main()
{
    highp vec2 tex0 = compute_frag_uv(vtex0);
    highp vec4 color = texture2D(diffuse, tex0) * vcol * global_color;
#ifdef HSV_SHIFT
    color.rgb = shift_col(color.rgb, hsv_params);
#endif
#ifdef COLOR_DODGE
    color = color_dodge_col(color);
#endif
#ifdef OVERLAY_MULTIPLY
    color = overlay_multiply_col(color);
#endif
#ifdef OVERLAY_SCREEN
    color = overlay_screen_col(color);
#endif
    gl_FragColor = color;

}