
uniform highp vec4 light_specular[kMaxLights];

#ifdef DEMATERIALIZING
varying highp vec2 vtex0;
uniform highp float dematerialization_time;
uniform highp float elapsed_time;
#endif

void main()
{
#ifdef DEMATERIALIZING
    highp float t1 = 2.0 * (dematerialization_time - elapsed_time);
    highp float t2 = 0.40*(0.5-mod(t1 * 5.0, 1.0)) + t1;
    highp vec2 coords = vec2(mod(vtex0.x * 10.0, 1.0), mod(vtex0.y * 10.0, 1.0));
    if(t2 < mod((13.2345 * coords.x + 0.367)*( 13.9824 *  coords.y  + 0.2345) , 1.0))
        discard;
#endif
    gl_FragColor = vec4(light_specular[1].rgb, light_specular[1].a*global_color.a);
}

