
#ifdef GL_ES
precision mediump float;
#endif

varying highp vec2 vtex0;
varying highp vec3 wNormal;
varying highp vec3 wTangent;
varying highp vec3 wBitangent;
varying highp vec3 wPosition;

uniform sampler2D diffuse;
uniform sampler2D normalmap;
uniform sampler2D specmap;
uniform sampler2D lightmap;
uniform sampler2D dynamic_lightmap;

uniform highp vec4 lightmap_offsetscale;

void main()
{
    vec4 specData = texture2D(specmap, vtex0);

    highp vec3 diffuseColor = texture2D(diffuse, vtex0).rgb;

    vec2 arenaCenter = wPosition.xz + lightmap_offsetscale.xy;
    vec2 lightMapCoords = clamp(arenaCenter*lightmap_offsetscale.zw + .5, 0., 1.);
    
    vec3 lightmapValue = texture2D(lightmap, lightMapCoords).rgb;
    
    vec2 dynamicLightMapCoords = (wPosition.xz) / vec2(18.0, 32.0);
    vec3 dynamicLightmapValue = texture2D(dynamic_lightmap, dynamicLightMapCoords).rgb;
    
    vec3 final_color = diffuseColor * (lightmapValue + dynamicLightmapValue) * 2.;

    gl_FragColor = vec4(final_color * global_color.rgb, global_color.a)*vcol;

}
