#ifdef GL_ES
precision highp float;
#endif

uniform mat4 transform;
varying highp vec3 world_position;
varying highp vec3 world_normal;
varying highp vec3 world_tangent;
varying highp vec3 world_bitangent;

varying vec2 vtex0;
varying vec2 vtex1;
attribute vec2 tex0;

#ifdef HAS_TEXT_COORDS2
attribute vec2 tex1;
#endif

#ifdef FOG
varying float vfog;
#endif



void main()
{
    mat3 model_matrix33 = mat3(transform[0].xyz, transform[1].xyz, transform[2].xyz);

#ifdef kHasAnimation
        mat4 anim = ix_animation_mat4_transpose();
        highp vec4 object_position = vec4(ix_pos_transform(anim), 1.0);
        highp vec3 object_normal   = ix_nml_transform(anim);
    #ifdef NORMALMAP
        highp vec3 object_tangent  = ix_tan_transform(anim);
        highp vec3 object_bitangent= ix_bin_transform(anim);
    #endif
#else
        highp vec4 object_position = vec4(ix_pos_transform(), 1.0);
        highp vec3 object_normal   = ix_nml_transform();
    #ifdef NORMALMAP
        highp vec3 object_tangent  = ix_tan_transform();
        highp vec3 object_bitangent= ix_bin_transform();
    #endif
#endif

    gl_Position = get_mvp() * object_position;

    world_position = (transform * object_position).xyz;
    world_normal   = normalize (model_matrix33 * object_normal);
#ifdef NORMALMAP
    world_tangent  = normalize (model_matrix33 * object_tangent);
    world_bitangent= normalize (model_matrix33 * object_bitangent);
#endif // NORMALMAP

    vtex0 = tex0;
    vtex1 = tex0;
#ifdef HAS_TEXT_COORDS2
    vtex1 = tex1;
#endif

#ifdef FOG
    vfog = ix_transform().z;
#endif
}
