#ifdef GL_ES
precision mediump float;
#endif

varying vec2 vtex0;
varying vec2 lmtex;

#ifdef STATIC_LIGHTMAP
varying vec2 vtex1;
#endif

uniform sampler2D diffuse;
uniform sampler2D dynamic_lightmap;

#ifdef STATIC_LIGHTMAP
uniform sampler2D lightmap;
#endif

highp vec3 fast_vec3pow(highp vec3 a, highp vec3 b)
{
    return a/((vec3(1.,1.,1.) - b)*a + b);
}

void main()
{
    highp vec3 dm = texture2D(diffuse, vtex0).rgb;
    highp vec3 lm = texture2D(dynamic_lightmap, lmtex).rgb;
#ifdef STATIC_LIGHTMAP
    lm += texture2D(lightmap, vtex1).rgb;
#endif
    gl_FragColor = vec4(fast_vec3pow(lm, vec3(0.45)) * dm, 1.0);
}
