attribute vec2 tex0;

#ifdef STATIC_LIGHTMAP
attribute vec2 tex1;
#endif

varying vec2 vtex0;
varying vec2 lmtex;

#ifdef STATIC_LIGHTMAP
varying vec2 vtex1;
#endif

uniform highp vec4 lightmap_offsetsize;

void main()
{
    gl_Position = ix_transform();
    vtex0 = tex0;
#ifdef STATIC_LIGHTMAP
    vtex1 = tex1;
#endif

    mat4 model = get_model_matrix();
    highp vec3 oPos = ix_pos_transform();
    highp vec3 wpos = (model * vec4(oPos, 1.)).xyz;
    lmtex = (wpos.xz - lightmap_offsetsize.xy) / lightmap_offsetsize.zw + vec2(0.5);
}
