
#ifdef GL_ES
precision mediump float;
#endif
varying highp vec3 lvec;
const float cutoff = 0.01;

void main()
{
    // attenuation:
    // vcol.a stores the light sphere radius
    // light intensity is included in vcol.rgb
    float r = vcol.a;
    float d = max(length(lvec) - r, 0.0);

    float dm = d / r + 1.0;
    float a = 1.0 / (dm * dm);

    // cutoff bias:
    a = (a - cutoff) / (1.0 - cutoff);
    a = max(a, 0.0);

    gl_FragColor = vec4(a * vcol.rgb, 1.0);
}
