varying vec2 vtex0;

varying vec3 vto_light;
varying vec3 vhalf;

attribute vec2 tex0;

uniform vec3 eye_dir_m;

uniform vec3 light_pos[kMaxLights];

void main()
{
    // These next two lines are only here to fix a bug on some Android
    // devices when this shadow shader is used as a replacement for a material
    // that uses the normal_mapped_vert shader normally
    // It might be that the uniform locations must match up for some
    // reason that I have not figured out yet
    vec3 to_light = light_pos[0] - pos;
    ix_tangent_space(to_light, eye_dir_m, vto_light, vhalf);
    
    vtex0 = tex0;
    gl_Position = ix_transform();
    
    // Use the same depth value for the whole mesh to prevent
    // blending shadow more than once per pixel
    
    // perspecive or orthographic camera
    //vec4 p = mvp * vec4(0.0, 0.0, 0.0, 1.0);
    //gl_Position.z = p.z * gl_Position.w / p.w;
    
    // orthographic camera only
    gl_Position.z = (get_mvp() * vec4(0.0, 0.0, 0.0, 1.0)).z ;
}
