varying highp vec2 vtex0;
varying highp vec2 vtex1;
varying highp vec2 vtex2;
varying highp vec2 vtex3;
varying highp vec2 vtex4;
varying highp vec2 vtex5;
varying highp vec4 clipPos;

varying highp float foam_blend;

uniform sampler2D diffuse;
uniform sampler2D sky;
uniform sampler2D normal;
uniform sampler2D lightmap;
uniform sampler2D foam;

uniform highp vec2 wave_height;
uniform highp float normal_bend;
uniform highp float diffuse_blend;

void main()
{
    highp vec4 tex_src0 = texture2D(diffuse, vtex0);
    highp vec3 nml1 = 2.0 * texture2D(normal, vtex2).xyz - vec3(1.0);
    highp vec3 nml2 = 2.0 * texture2D(normal, vtex3).xyz - vec3(1.0);

    highp vec2 reflection = (clipPos.xy / clipPos.w) / 2. + 0.5;
    nml1 = normalize(wave_height.x * nml1
                   + wave_height.y * nml2
                   + vec3(normal_bend * (2.0 * reflection - 1.0), 0.0));

    highp vec3 wcol = texture2D(sky, 0.5 * nml1.xy + vec2(0.5)).xyz;
    wcol = mix(wcol, tex_src0.rgb, diffuse_blend);
    highp vec3 foam1 = texture2D(foam, vtex4).rgb;
    highp vec3 foam2 = texture2D(foam, vtex5).rgb;
    highp vec3 foam_color = mix(foam1, foam2, foam2.r);
    gl_FragColor = vec4(mix(wcol, foam_color, foam_blend * foam_color.r), 1.0) * texture2D(lightmap, vtex1);
}
