varying vec2 vtex0;
varying vec2 vtex1;
varying highp vec2 vtex2;
varying highp vec2 vtex3;
varying highp vec2 vtex4;
varying highp vec3 vnml;
varying highp vec3 vpos;
varying highp vec4 clipPos;
varying highp vec3 eye_pos_frac;

uniform vec3 eye_dir_w;
uniform highp vec3 eye_pos_w;
uniform highp float water_scale;
uniform highp float scroll;

uniform highp float x_freq; // 2.
uniform highp float x_shift; // 4.
uniform highp float z_freq; // 2.4
uniform highp float z_shift; // 3.
uniform highp float wave_scale;

attribute vec2 tex0;
attribute vec2 tex1;

void main()
{
    vtex0 = compute_vertex_uv(tex0);
    vpos = ix_pos_transform();
    vec2 eye_pos_floor = floor(eye_pos_w.xz / 10000.0) * 10000.0;
    vpos.xz -= eye_pos_floor;
    eye_pos_frac = eye_pos_w.xyz;
    eye_pos_frac.xz -= eye_pos_floor;

    highp vec2 txt = vpos.xz * 0.001 * water_scale;
    highp float vscroll = scroll;
    vtex2 = txt - vscroll * 0.25;
    vtex3 = txt + vscroll * 0.45;
    vtex4 = txt.yx + vscroll * 0.25;

    vec4 lPos = vec4(ix_pos_transform(), 1.);
    // should only apply the curve to foam layer
    highp float waveV = sin(lPos.x * x_freq + x_shift * scroll)
                      + sin(lPos.z * z_freq + z_shift * scroll);
    lPos.y += waveV * wave_scale * (1.0 - tex0.y);

    clipPos = get_mvp() * lPos;

    vtex0 = tex0;
    vtex1 = tex0;
#ifdef HAS_TEXT_COORDS2
    vtex1 = tex1;
#endif

    vcol = ix_vertex_color();
    gl_Position = clipPos;
}
