varying highp vec2 vtex0;
varying highp vec2 vtex1;
varying highp vec2 vtex2;
varying highp vec2 vtex3;
varying highp vec2 vtex4;
varying highp vec2 vtex5;
varying highp float foam_blend;
varying highp vec4 clipPos;

uniform highp float scroll;
uniform highp vec2 wave_scale;
uniform highp vec2 wave_speed;

attribute highp vec2 tex0;
attribute highp vec2 tex1;

void main()
{
    vtex0 = tex0;
    vtex1 = tex0;
#ifdef HAS_TEXT_COORDS2
    vtex1 = tex1;
#endif

    // foam
    vtex4 = vec2(tex0.x, tex0.y + 0.2 * scroll);
    vtex5 = vec2(tex0.x, tex0.y - 0.1 * scroll);
    foam_blend = 1.0 - tex0.y;
    foam_blend *= foam_blend;

    // water
    highp vec3 vpos = ix_pos_transform();
    highp vec2 txt = vpos.xz * 0.001;

    vtex2 = wave_scale.x * txt + wave_speed.x * scroll;
    vtex3 = wave_scale.y * txt + wave_speed.y * scroll;

    vec4 lPos = vec4(vpos, 1.);

    clipPos = get_mvp() * lPos;

    gl_Position = clipPos;
}
