#ifdef GL_ES
precision mediump float;
#endif

varying highp vec2 vtex0;
varying highp vec2 vtex1;
varying highp vec4 vtint;

uniform sampler2D diffuse;
uniform sampler2D lightmap;

uniform highp float lmap_mult;
uniform highp float lmap_add;
uniform highp float lmap_gamma;

highp vec3 fast_vec3pow(highp vec3 a, highp vec3 b)
{
    return a/((vec3(1.,1.,1.) - b)*a + b);
}

void main()
{
    highp vec4 diffuseColor = texture2D (diffuse, vtex0);

    highp vec3 lmap = fast_vec3pow (texture2D (lightmap, vtex1).rgb, vec3 (lmap_gamma));
    lmap += lmap_add;
    lmap *= lmap_mult;
    lmap *= fast_vec3pow (diffuseColor.rgb, vec3 (lmap_gamma));

    highp vec4 outcolor;
    outcolor.rgb = fast_vec3pow (lmap, vec3 (1.0/lmap_gamma));
    outcolor.a = diffuseColor.a;

    outcolor *= vtint * global_color; // highlighting

    gl_FragColor = outcolor;
}
