// projected shadow

uniform highp vec3 light_dir[kMaxLights];

uniform mat4 view_matrix;

void main()
{
    mat4 model = get_model_matrix();
    highp vec3 oPos = ix_pos_transform();
    vec4 tnml = vec4(nml, 0.0);     // fix Android hack
                                    // This needs to be after the first pos
                                    // access to work on the older kindles

    // transform light direction to model space (quick inverse rotation)
    highp mat3 transform3 = mat3(model[0].xyz, model[1].xyz, model[2].xyz);
    highp vec3 mLightDir = normalize(light_dir[1] * transform3);

    // project shadow onto "ground"
    oPos -= mLightDir*oPos.y/mLightDir.y;

    highp vec4 clipPos = get_mvp() * vec4(oPos, 1.);
    // perform our own perspecive divide to make sure
    // we can make the depth match exactly for each shadow pixel
    if (clipPos.w > 0.)
        clipPos = vec4(clipPos.xy/clipPos.w, .9999, 1.);
    gl_Position = clipPos;
}
