varying vec2 vtex0;
varying vec2 vtex1;
varying highp vec2 vtex2;
varying highp vec2 vtex3;
varying highp vec2 vtex4;
varying highp vec3 vnml;
varying highp vec3 vpos;
varying highp vec4 clipPos;
varying highp vec3 eye_pos_frac;

uniform vec3 eye_dir_w;
uniform highp vec3 eye_pos_w;
uniform highp float water_scale;
uniform highp float scroll;

attribute vec2 tex0;
attribute vec2 tex1;



void main()
{
    vpos = ix_pos_transform();
    vec2 eye_pos_floor = floor(eye_pos_w.xz / 10000.0) * 10000.0;
    vpos.xz -= eye_pos_floor;
    eye_pos_frac = eye_pos_w.xyz;
    eye_pos_frac.xz -= eye_pos_floor;

    highp vec2 txt = vpos.xz * 0.001 * water_scale;
    highp float vscroll = mod(scroll, 20.);
    vtex2 = txt - vscroll * 0.25;
    vtex3 = txt + vscroll * 0.45;
    vtex4 = txt.yx + vscroll * 0.25;

    vec4 lPos = vec4(ix_pos_transform(), 1.);
    // should only apply the curve to foam layer
    // highp float waveV = sin(lPos.x * 2. + 4. * scroll) * 20.
    //                   + sin(lPos.z * 2.4 + 3. * scroll) * 20.;
    // lPos.y = waveV;

    clipPos = get_mvp() * lPos;

    vcol = ix_vertex_color();

    vtex0 = tex0;
    vtex1 = tex0;
#ifdef HAS_TEXT_COORDS2
    vtex1 = tex1;
#endif

    gl_Position = clipPos;
}
