#ifdef GL_ES
precision mediump float;
#endif

varying vec2 vtex0;
varying vec3 wPosition;

uniform sampler2D diffuse;
uniform sampler2D lightmap;
uniform sampler2D dynamic_lightmap;

uniform highp vec4 lightmap_offsetscale;

void main()
{
    highp vec4 diffuseColor = texture2D(diffuse, vtex0);

    vec2 arenaCenter = wPosition.xz + lightmap_offsetscale.xy;
    vec2 lightMapCoords = clamp(arenaCenter*lightmap_offsetscale.zw + .5, 0., 1.);
    
    vec3 lightmapValue = texture2D(lightmap, lightMapCoords).rgb;
    
    vec2 dynamicLightMapCoords = (wPosition.xz) / vec2(18.0, 32.0);
    vec3 dynamicLightmapValue = texture2D(dynamic_lightmap, dynamicLightMapCoords).rgb;
    
    gl_FragColor = vec4(diffuseColor.rgb * (lightmapValue + dynamicLightmapValue) * 2., diffuseColor.a);
}
