varying highp vec2 vtex0;
varying highp vec2 vtex1;

uniform sampler2D diffuse;
uniform sampler2D overlay;

uniform lowp float scroll;

void main()
{
    highp vec4 diff = texture2D(diffuse, vtex0);
    highp float op = texture2D(overlay, vec2(vtex1.x + scroll, vtex1.y)).r * diff.a;
    highp vec4 color_add = diff * global_color;

    highp float color_sum = min(pow((color_add.r + color_add.g + color_add.b), 8.0), 1.0);
    highp vec4 adj_color = vec4(color_sum * 0.5, color_sum, 0.0, diff.a);

	gl_FragColor = adj_color + vec4(adj_color.r * op, adj_color.g * op, adj_color.b * op, diff.a);
}