varying highp vec2 vtex0;
varying highp vec3 vto_light[kMaxLights];
varying highp vec3 vhalf[kMaxLights];
varying highp vec3 vnml;


uniform sampler2D diffuse;
uniform sampler2D normalmap;

uniform highp vec4 light_diffuse[kMaxLights];
uniform highp vec4 light_ambient[kMaxLights];
uniform highp vec4 light_specular[kMaxLights];

uniform highp float shininess;

void main()
{
    
    highp vec4 light_color = vec4(0.0, 0.0, 0.0, 0.0);
    highp float diff = 0.0;
    highp float spec = 0.0;
    highp vec3 vnmln = normalize((2.0 * texture2D(normalmap, vtex0).rgb) - 1.0);
    
    for (int i = 0; i < int(kMaxLights); ++i)
    {
        diff = clamp(dot(vnmln, normalize(vto_light[i])), 0.0, 1.0);
        spec = clamp(pow(dot(vnmln, normalize(vhalf[i])), shininess), 0.0, 1.0);

        light_color += (spec * light_specular[i]) + (diff * light_diffuse[i]) + light_ambient[i];
    }
    highp vec4 final_color = texture2D(diffuse, vtex0) * global_color;
	gl_FragColor = vec4(final_color.rgb * light_color.rgb, final_color.a);
}