varying vec2 vtex0;
varying vec3 wPosition;
varying vec3 wNormal;
#ifdef HAS_TEXT_COORDS
varying vec3 wTangent;
varying vec3 wBitangent;

attribute vec2 tex0;
#endif

uniform mat4 transform;


void main()
{
    mat4 model = get_model_matrix();

    #ifdef kHasAnimation
      mat4 anim = ix_animation_mat4_transpose();
      highp vec3 oPos = ix_pos_transform(anim);
      vec3 objectSpaceNormal = ix_nml_transform(anim);
      #ifdef HAS_TEXT_COORDS
          vec3 objectSpaceTangent = ix_tan_transform(anim);
      #endif
    #else
      highp vec3 oPos = ix_pos_transform();
      vec3 objectSpaceNormal = ix_nml_transform();
      #ifdef HAS_TEXT_COORDS
          vec3 objectSpaceTangent = ix_tan_transform();
      #endif
    #endif

    // compute gl_Position first to force z to match depth_only.prog
    gl_Position = camera * model * vec4(oPos, 1.); //ix_transform();



    // must normalize because transform can contain a scale
    mat3 transform3 = mat3(model[0].xyz, model[1].xyz, model[2].xyz);
    wNormal = normalize(transform3 * objectSpaceNormal);

#ifdef HAS_TEXT_COORDS
    wTangent = transform3 * objectSpaceTangent;
    wBitangent = normalize(cross(wNormal, wTangent));
    wTangent = cross(wBitangent, wNormal);
    vtex0 = tex0;
#endif
    wPosition = (model * vec4(oPos, 1.)).xyz;

    vcol = vec4(1.0,1.0,1.0,1.0); //Needed to share fragment shader with massanimation.prog
}
