#ifdef GL_ES
precision highp float;
#endif

uniform mat4 transform;
varying highp vec3 world_position;
varying highp vec3 world_normal;
varying highp vec3 world_tangent;
varying highp vec3 world_bitangent;

varying vec2 vtex0;
varying vec2 vtex1;
attribute vec2 tex0;

#ifdef HAS_TEXT_COORDS2
attribute vec2 tex1;
#endif

#ifdef FOG
varying float vfog;
#endif



void main()
{
    highp vec4 object_position = vec4(ix_pos_transform(), 1.0);
    world_position = (transform * object_position).xyz;
    gl_Position = get_mvp() * object_position;

    mat3 model_matrix33 = mat3(transform[0].xyz, transform[1].xyz, transform[2].xyz);
    world_normal = normalize (model_matrix33 * ix_nml_transform());

#ifdef NORMALMAP
    highp vec3 object_tangent = ix_tan_transform();
    world_tangent = model_matrix33 * ix_tan_transform();
    world_bitangent = normalize (cross (world_normal, world_tangent)); // aka binormal
    world_tangent = cross (world_bitangent, world_normal);
#endif // NORMALMAP

    vtex0 = tex0;
    vtex1 = tex0;
#ifdef HAS_TEXT_COORDS2
    vtex1 = tex1;
#endif

#ifdef FOG
    vfog = ix_transform().z;
#endif
}
