varying highp vec2 vtex0;
varying highp vec3 vto_light;
varying highp vec3 vhalf;
varying highp vec3 vnml;

uniform sampler2D diffuse;

uniform highp vec4 light_diffuse[kMaxLights];
uniform highp vec4 light_ambient[kMaxLights];
uniform highp vec4 light_specular[kMaxLights];

uniform highp float shininess;

void main()
{
    highp vec3 vnmln = normalize(vnml);
    highp float diff = clamp(dot(vnmln, normalize(vto_light)), 0.0, 1.0);
    highp float spec = clamp(pow(dot(vnmln, normalize(vhalf)), shininess), 0.0, 1.0);

    highp vec4 light_color = (spec * light_specular[0]) + (diff * light_diffuse[0]) + light_ambient[0];
    highp vec4 final_color = texture2D(diffuse, vtex0) * global_color;
	gl_FragColor = vec4(final_color.rgb * light_color.rgb, final_color.a);
}