#define PI 3.141592653589793238462643383279

varying highp vec2 vtex0;

uniform sampler2D diffuse;
uniform highp float scroll;

uniform highp vec2 view_dimm_inv;

void main(void)
{
    lowp vec2 scale = vec2(15.0, 15.0) * sin(scroll * 0.25);
    highp vec2 ss = vec2(gl_FragCoord.x * view_dimm_inv.x, 1.0 - gl_FragCoord.y * view_dimm_inv.y);
    highp vec2 c = (ss * scale) - (scale * 0.5);

    highp float accum = 0.0;
    accum += sin((c.x + scroll));
    accum += sin((c.y + scroll) * 0.5);
    accum += sin((c.x + c.y + scroll) * 0.5);
    c += scale * 0.5 * vec2(sin(scroll * 0.5), cos(scroll * 0.5));
    accum += sin(sqrt(c.x * c.x + c.y * c.y + 1.0) + scroll);
    accum = accum / 16.0;

    // blue
    // highp float r = sin(PI * 1.0 * accum);
    // highp float g = sin(PI * 1.0 * accum);
    // highp float b = cos(PI * 1.0 * accum);

    // yellow
    // highp float r = cos(PI * 1.0 * accum);
    // highp float g = cos(PI * 1.0 * accum);
    // highp float b = sin(PI * 1.0 * accum);

    // green
    highp float r = sin(PI * 1.0 * accum);
    highp float g = cos(PI * 2.0 * accum);
    highp float b = sin(PI * 0.1 * accum);
    highp vec3 plasma = vec3(r, g, b);

    gl_FragColor = vec4(plasma + 0.5, 1.0) * texture2D(diffuse, vtex0);
}