
varying lowp vec2 vtex0;
varying lowp vec2 vtex1;
varying highp vec3 vnml;
varying highp vec3 vpos;

uniform sampler2D diffuse;
uniform sampler2D specular;

uniform vec3 camera_pos_w;
uniform float shininess;
uniform float scroll;

const vec3 light_source = vec3(0, 0, 50);
const float amb = 0.2;

void main()
{
	vec3 lightvec = normalize(light_source - vpos);
	vec3 halfvec = normalize((camera_pos_w + lightvec) * 0.5);
    
	vec3 shimmer = texture2D(specular, vtex1 + vec2(scroll, 0.0)).xyz;
    
	float diff = dot(lightvec, vnml);
	float spec = pow(max(dot(halfvec, vnml), 0.0), shininess);
	
    
	vec4 tex_src0 = texture2D(diffuse, vtex0);
	vec3 col = (tex_src0.xyz + shimmer) * (diff + spec + amb);
	float a = tex_src0.a;
    
	gl_FragColor = vec4(col, a);
    
	
}